unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ThreadDone(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  TMyThread = class(TThread)
  protected
    procedure Execute;
  end;

var
  Form1: TForm1;

implementation

var
  FL: Integer;
  FS: TMyThread;
{$R *.dfm}

procedure TMyThread.Execute;
begin
  //    
  repeat
    Inc(FL);
    Sleep(100);
    Beep;
  until (FL >= 30) or Terminated;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if FS <> nil then Exit;
  FS := TMyThread.Create(True);
  with FS do
  begin
    FreeOnTerminate := True;
    OnTerminate := ThreadDone;
    Resume;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if FS <> nil then FS.WaitFor;
  ShowMessage('');
end;

procedure TForm1.ThreadDone(Sender: TObject);
begin
  FS := nil;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FL:=0;
end;

end.
